/***************************************************************************
                          kclipspellapplet.cpp  -  description
                             -------------------
    begin                : Nov 6 2003
    copyright            : (C) 2003 by Gary Cramblitt
    email                : garycramblitt@comcast.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kclipspellapplet.h"

#include <kglobal.h>
#include <klocale.h>
#include <kapplication.h>
#include <kaboutapplication.h>

KClipSpellApplet::KClipSpellApplet(const QString& configFile, Type type, int actions, QWidget *parent, const char *name) 
    : KPanelApplet(configFile, type, actions, parent, name)
{
    // Construct a clickable button.
    m_button = new CSPushButton( this );
    connect( m_button, SIGNAL( about() ), this, SLOT( about() ) );
}


KClipSpellApplet::~KClipSpellApplet()
{
}


void KClipSpellApplet::about()
{
    KAboutData about
        (
            "kclipspellapplet",
            I18N_NOOP("KClipSpellApplet"),
            VERSION,
            I18N_NOOP("<qt>KClipSpellApplet is a kicker applet.  To use, "
            "highlight text in any application, press Ctrl-C, and click the Clipboard Spellcheck button.</qt>"),
            KAboutData::License_GPL_V2,
            "(C) 2003 Gary Cramblitt", 0,  "garycramblitt@comcast.net"
        );

    about.addAuthor("Gary Cramblitt", 0, "garycramblitt@comcast.net", "" );
       
    KAboutApplication a(&about, this);
    a.exec();  
}

int KClipSpellApplet::widthForHeight(int height) const
{
    int w = (2 * height) / 3;
    m_button->setFixedSize( w, w );
    m_button->move( 0, height/6 );
    return w;
}

int KClipSpellApplet::heightForWidth(int width) const
{
    int h = (2 * width) / 3;
    m_button->setFixedSize( h, h );
    m_button->move( width/6, 0 );
    return h;
}

extern "C"
{
    KPanelApplet* init( QWidget *parent, const QString configFile)
    {
        KGlobal::locale()->insertCatalogue("kclipspellapplet");
        return new KClipSpellApplet(configFile, KPanelApplet::Normal,
                             KPanelApplet::About,
                             parent, "kclipspellapplet");
    }
}

#include "kclipspellapplet.moc"
